<template>
  <div>
    <!-- Cuerpo -->
    <div class="padding-top">
      <el-header height="110px" style="margin: 0 12rem;">
        <ReturnButton v-on:clickEvent="verifyEditModal" title="Ir a Segmentos" :offsetArrow="20" :spanTitle="3" class="text-end"></ReturnButton>
        <!-- Modal del btn de retroceso -->
        <AppModalReturn :show-dialog.sync="returnButtonModal" v-if="returnButtonModal" v-on:btnEvent="returnButtonModal = false" @btnEvent="viewListSegments" v-on:eventBtn="returnButtonModal = false">
        </AppModalReturn>
        <el-col :span="24" style="padding-top: 1.5rem">
          <el-card :body-style="{ padding: '10px' }" shadow="never" class="bg-form text-white title-views">NUEVO SEGMENTO </el-card>
        </el-col>
      </el-header>
      <el-main style="margin: 3rem 12.5rem">
        <el-form :rules="rules" ref="formSegment" :model="formSegment">
          <!-- titulo -->
          <h4 class="text-orange" style="margin-bottom:2rem">TÍTULO DEL SEGMENTO</h4>
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item label="Título:" prop="segmentTitle" class="inputTitle">
                <el-input v-model="formSegment.segmentTitle" size="small"></el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin:2.5rem 0">

          <!-- PROGRAMA DEL SEGMENTO -->
          <h4 class="text-orange" style="margin-bottom:2rem">PROGRAMA DEL SEGMENTO</h4>
          <el-row style="margin-bottom: 20px;">
            <el-col :span="23" :offset="1">
              <el-form-item label="Código:" prop="codeProgram" class="inputTitle">
                <el-autocomplete
                    v-model="formSegment.codeProgram"
                    size="small"
                    :fetch-suggestions="querySearchCode"
                    :trigger-on-focus="false"
                    @select="handleSelectCode">
                  <template slot-scope="props">
                    <div>{{ props.item.codProgram }}</div>
                  </template>
                </el-autocomplete>
              </el-form-item>
            </el-col>
          </el-row>
          
          <el-row style="margin-bottom: 20px;">
            <el-col :span="23" :offset="1">
              <el-form-item label="Título:" prop="programTitle" class="inputTitle">
                <el-autocomplete
                  v-model="formSegment.programTitle"
                  style="width: 100%;"
                  size="small"
                  :fetch-suggestions="querySearch"
                  :trigger-on-focus="false"
                  @select="handleSelect">
                  <template slot-scope="props">
                    <div>{{ props.item.programTitle }}</div>
                  </template>
                </el-autocomplete>
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin:2.5rem 0">

          <!-- VIGENCIA DEL SEGMENTO -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">VIGENCIA</h4>
          <el-row type="flex" align="middle">
            <!-- INICIO DE VIGENCIA  -->
            <el-col :span="11" :offset="1">
              <el-form-item prop="validity[0].startValidity" label="Inicio:" class="selectInput">
                <el-date-picker
                  v-model="formSegment.validity[0].startValidity" type="date" placeholder="Seleccionar"
                  format="dd/MM/yyyy" size="small"> 
                </el-date-picker>       
              </el-form-item>
            </el-col>
            <!-- FIN DE VIGENCIA -->
            <el-col :span="11" :offset="1">
              <el-form-item prop="validity[0].endValidity" label="Fin:" class="selectInput">
                <el-date-picker
                  v-model="formSegment.validity[0].endValidity" type="date" placeholder="Seleccionar"
                  format="dd/MM/yyyy" size="small" :picker-options="datePickerOptions"> 
                </el-date-picker>        
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin-top:2.5rem">

          <!-- HORARIO DEL SEGMENTO -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">HORARIO DEL SEGMENTO</h4>
          <el-row style="margin-bottom:3rem">
            <el-col :span="11" :offset="1">
              <el-row type="flex" align="middle">
                <el-col :span="6">
                  <span class="font-general">Inicio:</span>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleStartHour" class="inputTitle">
                    <el-input size="small" v-model="formSegment.scheduleStartHour" placeholder="00" v-on:keypress.native="isNumber" ref="jump4" @keyup.enter.native="$refs.jump1.focus" maxlength="2">
                      <template slot="append">hr</template>
                    </el-input>
                  </el-form-item>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleStartMin" class="inputTitle">
                    <el-input size="small" v-model="formSegment.scheduleStartMin" placeholder="00" v-on:keypress.native="isNumber" ref="jump1" @keyup.enter.native="$refs.jump2.focus" maxlength="2">
                      <template slot="append">min</template>
                    </el-input>
                  </el-form-item>
                </el-col>
              </el-row>  
            </el-col>

            <el-col :span="11" :offset="1">
              <el-row type="flex" align="middle">
                <el-col :span="6">
                  <span class="font-general">Fin:</span>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleEndHour" class="inputTitle">
                    <el-input size="small" v-model="formSegment.scheduleEndHour" placeholder="00" v-on:keypress.native="isNumber" ref="jump2" @keyup.enter.native="$refs.jump3.focus" maxlength="2">
                      <template slot="append">hr</template>
                    </el-input>
                  </el-form-item>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleEndMin" class="inputTitle">
                    <el-input size="small" v-model="formSegment.scheduleEndMin" placeholder="00" v-on:keypress.native="isNumber" ref="jump3" @keyup.enter.native="$refs.jump4.focus" maxlength="2">
                      <template slot="append">min</template>
                    </el-input>
                  </el-form-item>
                </el-col> 
              </el-row>
            </el-col>
          </el-row>
          <hr style="margin-top:2.5rem">

          <!-- DIAS DE TRANSMISION -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">DÍAS DE TRANSMISIÓN</h4>
          <el-row type="flex" align="middle">
            <el-col :span="23" :offset="1">
              <el-form-item prop="transmissionDays" class="font-general">
                <el-radio-group v-model="transmission" @change="weeksChange" style="margin-bottom:1.5rem">
                  <el-radio :label="3" style="margin-right: 1.7rem">Todos los días</el-radio>
                  <el-radio :label="6" style="margin-right: 1.7rem">Lunes a Viernes</el-radio>
                  <el-radio :label="9" style="margin-right: 1.7rem">Sábados y Domingos</el-radio>
                </el-radio-group>
                <el-checkbox-group v-model="formSegment.transmissionDays" @change="handleCheckedDaysChange">
                  <el-checkbox-button v-for="day in days" :label="day" :key="day">{{day}}</el-checkbox-button>
                </el-checkbox-group>
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin-top:2.5rem">

          <!-- SEÑALES --> 
          <h4 class="text-orange" style="margin: 3rem 0 2rem">SEÑALES</h4>
          <el-row style="margin: 0.7rem 0 1rem">          
            <el-col :span="6">
              <el-checkbox :indeterminate="isIndeterminate" v-model="checkAll" @change="handleCheckAllChange" border>Todas las señales</el-checkbox>
            </el-col>
            <el-col :span="6"><el-button @click="signalModal = true">Seleccionar</el-button></el-col>          
            <!-- Modal -->
            <el-dialog
              :visible.sync="signalModal"
              width="40%"
              center
              :close-on-press-escape="false"
              custom-class="dialog-orange">
              <el-form-item style="margin: 0" prop="checkedSignals">
                <el-checkbox-group v-model="formSegment.checkedSignals" @change="handleCheckedSignalsChange" class="text-center" style="margin-left: 3rem;">
                  <el-checkbox  v-for="signal in signals" :label="signal" :key="signal" style="width: 30%; margin: 0" class="text-start">{{signal}}</el-checkbox>
                </el-checkbox-group>              
              </el-form-item>
              <div style="text-align: right; margin-top: 20px">
                <el-button @click="signalModal = false" class="text-orange border-orange">CANCELAR</el-button>
                <el-button @click="signalModal = false" type="primary">ACEPTAR</el-button>
              </div>
            </el-dialog>
          </el-row>
          <el-form-item style="margin: 0 0 4rem" prop="checkedSignals">
            <div class="bg-gray" style="display: table; height: 8rem; width:100%; padding: 10px 7px 7px">
              <el-col v-for="(item, j) in  formSegment.checkedSignals" :key="j" 
                class="bg-white" style="margin:7px; padding:0 5px; width:8rem">{{item}} </el-col>
            </div>
          </el-form-item>
          <!-- Botón cancelar e ingresar -->
          <div class="text-end">
            <el-button v-on:click="modalCancelButton = true" class="text-orange border-orange">CANCELAR</el-button>
            <!-- <el-button @click="onSubmitSegment" v-on:click="addSegmentModal = true" type="primary">INGRESAR</el-button>  -->
            <el-button @click="submitForm('formSegment')" type="primary">INGRESAR</el-button> 
          </div>
          <!-- Modal botón cancelar -->
           <AppModalDanger :show-dialog.sync="modalCancelButton" v-if="modalCancelButton"  v-on:btnEvent="viewListSegments"  @btnEvent="modalCancelButton = false" v-on:eventBtn="modalCancelButton = false">
           </AppModalDanger>

          <AppModalSuccess 
            :show-dialog.sync="addSegmentModal" 
            v-if="addSegmentModal"  
            widthModal="35%"
            :styleModal="true"
            :show="false"
            :parrafo="`El segmento <strong> ' ${formSegment.segmentTitle.toProperCase() }' </strong> se ha agregado a la lista. <br> Su código es <strong>${ nuevocodigoProgram }</strong> . ` "
            btn1="Ver segmentos"
            btn2="Nuevo segmento"
            v-on:btnEvent="addSegmentModal = false" @btnEvent="viewListSegments"
            @eventBtn="addSegmentModal = false"
            v-on:eventBtn="cleanAllInputs('formSegment')" >
          </AppModalSuccess>

          <!-- MODAL DE FORMULARIO INVALIDO -->
          <AppModal :show-dialog.sync="invalidForm" v-if="invalidForm" nameClass="dialog-red" 
            :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80%"  
            :parrafo="'Por favor, ingrese todos los campos requeridos.'">
          </AppModal>

          <!-- MODAL DE LOS SECUENCES DESFAZADOS  -->
          <el-dialog
            :visible.sync="isModalSecuences"
            width="35%"
            center
            :show-close="false"
            custom-class="dialog-red">
            <el-row>
              <el-col :span="6"><img src="../../assets/images/alerta.svg" width="70%" alt="emoticon"></el-col>
              <el-col :span="18">
                <!-- <p style="margin-bottom: 0.5rem"><strong> ERROR !!</strong></p> -->
                <p style="line-height: 22px;">Los códigos generados por la plataforma Géminis no <span class="text-red text-bold"> COINCIDEN </span> . </p> <br>
                <p style="line-height: 22px;">Comunicarse con el área de  <strong> DESARROLLO - BACK OFFICE </strong>.</p>
              </el-col>
            </el-row>
          </el-dialog>

        </el-form>
      </el-main>
    </div>
  </div>
</template>

<script>
// IMPORTAR COMPONENTES
import AppModal from '@/components/AppModal.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import AppModalReturn from '@/components/AppModalReturn.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import ReturnButton from '@/components/ReturnButton.vue'
// IMPORTAR DESDE MAIN.JS
import { HTTP } from '@/main.js'
// IMPORTAR DESDE UTILS.JS
import { validateTime } from '@/utils/calculateTime.js'

const allWeek = ["Lunes", "Martes", "Miércoles", "Jueves", "Viernes", "Sábado", "Domingo"];
const week = ["Lunes", "Martes", "Miércoles", "Jueves", "Viernes"];
const weekend = ["Sábado", "Domingo"];

String.prototype.toProperCase = function () {
  const re = /(^|[^A-Za-zÁÉÍÓÚÜÑáéíóúüñ])(?:([a-záéíóúüñ])|([A-ZÁÉÍÓÚÜÑ]))|([A-ZÁÉÍÓÚÜÑ]+)/gu;
  return this.replace(re,
        (m, caracterPrevio, minuscInicial, mayuscInicial, mayuscIntermedias) => {
            const locale = ['es', 'gl', 'ca', 'pt', 'en'];
            if (mayuscIntermedias)
                return mayuscIntermedias.toLocaleLowerCase(locale);
            return caracterPrevio
                 + (minuscInicial ? minuscInicial.toLocaleUpperCase(locale) : mayuscInicial);
        });
};

export default {
  components: {
    ReturnButton,
    AppModalDanger,
    AppModalReturn,
    AppModalSuccess,
    AppModal
  },
  data () {
    return {
      signalsTable: [], //Desde DB - Señales
      formSegment: {
        segmentTitle: "",
        codeProgram: "",
        programTitle: "",
        segmentClassification: "",
        segmentDescription:"",
        transmissionDays: [],
        transmissionDaysDescription: [],
        checkedSignals: [],
        scheduleStartHour:"",
        scheduleStartMin:"",
        scheduleEndHour:"",
        scheduleEndMin:"",
        validity: [
          { startValidity: '',
            endValidity: ''   }
        ],
      },
      rules: {
        segmentTitle: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        codeProgram: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        programTitle: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        validity: [
          { 
            startValidity: [{ required: true, message: 'Por favor seleccione un valor', trigger: 'change' }],
            endValidity: [{ required: true, message: 'Por favor seleccione un valor', trigger: 'change' }]
          }
        ],
        segmentClassification: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        segmentDescription: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleStartHour: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleStartMin: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleEndHour: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleEndMin: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        transmissionDays: [
          { required: true, message: 'Por favor seleccione los días de transmisión', trigger: 'change' },
        ],
        checkedSignals: [
          { required: true, message: 'Por favor seleccione las señales', trigger: 'change' },
        ]
      },
      transmission: [],
      days: allWeek,
      weekend: weekend,
      laboralDays: week,
      isIndeterminate: false,
      checkAll: true,
      signalModal: false,
      addSegmentModal: false,
      returnButtonModal: false,
      modalCancelButton: false,
      datePickerOptions: {
        disabledDate: this.disabledValidityDate
      },
      userName: '',
      userEmail: localStorage.getItem('userEmail'),
      segmentsArr: [],
      code: '',
      links: [],
      // programTitle: "",
      // codeProgram: "",
      contador: 0,
      codigoDias: [],
      numberWeek: [2, 3, 4, 5, 6, 7, 1],
      arrSignalsCode: [],
      signalsByCode: '',
      nuevoCodigoGeminis: '',
      ultimoCodigoDeGeminis: '',
      ultimoCodigoDePrograma: '',
      ultimoCodigoDeGeminisSegunSegmentos: '',
      createdNewSegment: false,
      invalidForm: '',
      isModalSecuences: false,
      nuevocodigoProgram: ''
    }
  },
  
  computed: {
    verifyChangeModal () {
      const array = [
       this.formSegment.segmentTitle,
       this.formSegment.segmentClassification,
       this.formSegment.segmentDescription,
       this.formSegment.transmissionDays.length,
       this.formSegment.transmissionDaysDescription.length,
       this.formSegment.checkedSignals.length,
       this.formSegment.scheduleStartHour,
       this.formSegment.scheduleStartMin,
       this.formSegment.scheduleEndHour, 
       this.formSegment.scheduleEndMin,
       this.formSegment.validity[0].endValidity,
       this.formSegment.validity[0].startValidity,
       this.formSegment.programTitle,
       this.formSegment.codeProgram 
    ].join()
      return array
    },
    signals () {
      let dataTables = this.$store.state.tables;
      for (let i = 0; i < dataTables.length; i++) {
        if (dataTables[i].tableName === 'allSignals') {
          this.signalsTable = dataTables[i].types
          this.signalsByCode = dataTables[i].description
          return dataTables[i].types
        }
      }
    }
  },
   created () {
    this.getTables ()
    this.getAllSignals()
    this.gettingUsername()
  },
  methods: {
    getAllSignals(){
      this.arrSignalsCode = [
        "AR",
        "CY",
        "CH",
        "DG",
        "HU",
        "LI",
        "PI",
        "PC",
        "T1",
        "T2",
        "TC",
        "TR",
        "WE",
        "PN",
        "CU",
        "IC",
        "TP",
        "IQ",
        "TB",
        "CJ",
        "DI",
        "CN",
        "TE"
      ]
      this.formSegment.checkedSignals = [
        "Arequipa",
        "Chiclayo",
        "Chimbote",
        "Digital",
        "Huancayo",
        "Lima",
        "Piura",
        "Pucallpa",
        "T1",
        "T2",
        "Tacna",
        "Trujillo",
        "Web",
        "Puno",
        "Cusco",
        "Ica",
        "Tarapoto",
        "Iquitos",
        "Tumbes",
        "Cajamarca",
        "Discovery Channel",
        "Canal N",
        "Televisa"
      ]
    },
    gettingUsername(){
      let user = this.userEmail.split('@')[0]
      this.userName = user.toUpperCase()
    },
    // getLastCode () {   
    //   HTTP.get('lastCollection')
    //   .then(res => { 
    //     this.ultimoCodigoDeGeminis = res.data.lastCode 
    //   })
    //   .catch(err => {
    //     console.log(err);
    //   });
    // },
    verifyEditModal () {
      if(this.contador > 0) {
        this.returnButtonModal = true
      }
      else {
        this.$router.push({name: 'segments'})
      }
    },
    querySearch(queryString, cb) {
      var links = this.$store.state.allPrograms
      var results = queryString ? links.filter(this.createFilter(queryString)) : links;
      console.log(results, 'results')
      cb(results);
    },
    createFilter(queryString) {
      return (link) => {
        return (link.programTitle.toLowerCase().indexOf(queryString.toLowerCase()) !== -1);
      };
    },
    handleSelect(item) {
      this.formSegment.programTitle = item.programTitle
      this.formSegment.codeProgram = item.codProgram
    },
    querySearchCode(queryString, cb) {
      var links = this.links;
      var results = queryString ? links.filter(this.createFilterCode(queryString)) : links;
      cb(results);
    },
    createFilterCode(queryString) {
      return (link) => {
        return (link.codProgram.toLowerCase().indexOf(queryString.toLowerCase()) !== -1);
      };
    },
    handleSelectCode(item) {
      this.formSegment.programTitle = item.programTitle
      this.formSegment.codeProgram = item.codProgram
    },
    submitForm(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          this.onSubmitSegment()
          this.addSegmentModal = true
        } else {
          this.invalidForm = true
          return false;
        }
      });
    },
    onSubmitSegment () {
      let transmissionDaysToFilter = this.formSegment.transmissionDays;
      let missingDays = this.days.filter(function(obj) { return transmissionDaysToFilter.indexOf(obj) == -1; });
      let daysLeftover = this.days.filter(function(obj) { return missingDays.indexOf(obj) == -1; });
      this.formSegment.transmissionDays = daysLeftover;
      
      if (this.formSegment.scheduleStartHour.length === 1) {
        this.formSegment.scheduleStartHour = "0" + this.formSegment.scheduleStartHour;
      }
      if (this.formSegment.scheduleStartMin.length === 1) {
        this.formSegment.scheduleStartMin = "0" + this.formSegment.scheduleStartMin;
      }
      if (this.formSegment.scheduleEndHour.length === 1) {
        this.formSegment.scheduleEndHour = "0" + this.formSegment.scheduleEndHour;
      }
      if (this.formSegment.scheduleEndMin.length === 1) {
        this.formSegment.scheduleEndMin = "0" + this.formSegment.scheduleEndMin;
      }
      if(this.formSegment.transmissionDays.join() == this.laboralDays.join()){
        this.formSegment.transmissionDaysDescription = 'De Lunes a Viernes'
      } 
      if(this.formSegment.transmissionDays.join() != this.laboralDays.join() && this.formSegment.transmissionDays.length !== 7) {
        let description = this.formSegment.transmissionDays.join(', ');
        this.formSegment.transmissionDaysDescription = description.replace(/,(?=[^,]*$)/, ' y');
      }
      if(this.formSegment.transmissionDays.join() == this.weekend.join()) {
        this.formSegment.transmissionDaysDescription = 'Sábados y domingos'
      }
      if(this.formSegment.transmissionDays.length === 7){
        this.formSegment.transmissionDaysDescription = 'Todos los dias'
      }

      //Generar Código
      // this.generateCodeSegmentsAndGeminis()
      //Recorriendo materiales para verificar si se repite codigo

      let hoursInicio = this.convertHourDate(this.formSegment.validity[0].startValidity, this.formSegment.scheduleStartHour, this.formSegment.scheduleStartMin)
      let hoursFin = this.convertHourDate(this.formSegment.validity[0].endValidity, this.formSegment.scheduleEndHour, this.formSegment.scheduleEndMin)

      let newSegment = {
        programTitle: this.formSegment.programTitle,
        codeProgram: this.formSegment.codeProgram,
        codSegment: null,
        segmentTitle: this.formSegment.segmentTitle.toProperCase(),
        transmissionDays: this.formSegment.transmissionDays,
        transmissionDaysDescription: this.formSegment.transmissionDaysDescription,
        checkedSignals: this.formSegment.checkedSignals,
        scheduleStartHour: this.formSegment.scheduleStartHour,
        scheduleStartMin: this.formSegment.scheduleStartMin,
        scheduleEndHour: this.formSegment.scheduleEndHour,
        scheduleEndMin: this.formSegment.scheduleEndMin,
        validity: [
           { startValidity: this.formSegment.validity[0].startValidity.toLocaleDateString('en-GB'),
             endValidity: this.formSegment.validity[0].endValidity.toLocaleDateString('en-GB')
           }
        ],
        vigencia: [{
          startValidity: this.formSegment.validity[0].startValidity.toLocaleDateString('en-GB'),
          endValidity: this.formSegment.validity[0].endValidity.toLocaleDateString('en-GB'),
          hourStart: hoursInicio,
          hoursEnd: hoursFin
        }],
        userName: this.userName,
        userEmail: this.userEmail,
        signalsCode: this.arrSignalsCode,
        codeDays: this.codigoDias,
        geminisCode: null,
      };
      // console.log(newSegment, 'newSegment')
      // console.log(this.nuevocodigoProgram, "this.nuevocodigoProgram")

      HTTP.post('segments', newSegment)
        .then(res => {
          
          console.log(res.data)
          if (res.data.isEqualSequences) {
            this.nuevocodigoProgram = res.data.newCodeProgram
            this.addProgramModal = true

            let dataType = "segments"
            this.$store.dispatch("getData", dataType)

          }
          else {
            this.isModalSecuences = true
          }
        })
        .catch(err => {
          console.log(err)
        });
    },   
    getTables () {
      let dataType = 'tables'
      this.$store.dispatch("getData", dataType)
    },
    handleCheckAllChange (val) {
      this.formSegment.checkedSignals = val ? this.signalsTable : []
      this.isIndeterminate = false
      let arrCode = []
      let arrIndexCode = this.arraySignalCode(this.signalsTable)
      for(var r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.signalsByCode[arrIndexCode[r]])
      }
      this.arrSignalsCode = arrCode
      console.log(this.arrSignalsCode, "arrSignalsCode")
    },   
    handleCheckedSignalsChange (value) {
      let arrCode = []
      let checkedCount = value.length;
      this.checkAll = checkedCount === this.signals.length;

      let arrIndexCode = this.arraySignalCode(value)
      for(var r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.signalsByCode[arrIndexCode[r]])
      }
      this.arrSignalsCode = arrCode
      console.log(this.arrSignalsCode, "arrSignalsCode")
      this.isIndeterminate = checkedCount > 0 && checkedCount < this.signals.length
      
    },
    cleanAllInputs (formSegment) {
      this.$refs[formSegment].resetFields()
      this.transmission = []
      this.formSegment.checkedSignals = []
      this.isIndeterminate = true
      this.arrSignalsCode = []
      this.formSegment.programTitle = this.formSegment.codeProgram = ''
      this.getLastCode()
      this.createdNewSegment = true
    },
    viewListSegments () {
      this.createdNewSegment = false
      this.$router.push({name: 'segments'})
    },
    isNumber (evt) {
      evt = (evt) ? evt : window.event;
      var charCode = (evt.which) ? evt.which : evt.keyCode;
      if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
        evt.preventDefault();
      } else {
        return true;
      }      
    },
    bringDescription (val) { 
      if(this.formSegment.segmentClassification){
        var index=this.classifTable.types.indexOf(this.formSegment.segmentClassification)
        this.formSegment.segmentDescription = this.classifTable.description[index];
      }
    },
    weeksChange (val) {
      let arrCode = []
      let arrIndexCode
      if (this.transmission === 3) {
        this.formSegment.transmissionDays = val ? allWeek : []
        arrIndexCode = this.arrayDiasCode(allWeek)
      } else if (this.transmission === 6) {
        this.formSegment.transmissionDays = val ? week : []
        arrIndexCode = this.arrayDiasCode(week)
      } else if (this.transmission === 9) {
        this.formSegment.transmissionDays = val ? weekend : []
        arrIndexCode = this.arrayDiasCode(weekend)
      }
      for(var r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.numberWeek[arrIndexCode[r]])
      }
      this.codigoDias = arrCode
      console.log(this.codigoDias, "this.codigoDias")
    },
    handleCheckedDaysChange (value) {
      if (value.length === 7) {
        this.transmission = 3
      } else if (value.sort().join() == weekend.sort().join()) {
        this.transmission = 9
      } else  if (value.sort().join() == week.sort().join()) {
        this.transmission = 6
      } else {
        this.transmission = []
      }

      let arrCode = []
      let arrIndexCode = this.arrayDiasCode(value)
      for(var r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.numberWeek[arrIndexCode[r]])
      }
      this.codigoDias = arrCode
      console.log(this.codigoDias, "this.codigoDias")
    },
    disabledValidityDate (time) {
        return time.getTime() < this. formSegment.validity[0].startValidity
    },
    arrayDiasCode (val) {
      let arrayIndex = []
      for(var x=0; x<val.length; x++){
        for(var y=0; y<this.days.length; y++){
          if(this.days[y] == val[x]){
            arrayIndex.push(y)
          }
        }
      }
      return arrayIndex
    },
    arraySignalCode (val) {
      let arrayIndex = []
      for(var x=0; x<val.length; x++){
        for(var y=0; y<this.signals.length; y++){
          if(this.signals[y] == val[x]){
            arrayIndex.push(y)
          }
        }
      }
      return arrayIndex
    },
    // generateCodeSegmentsAndGeminis () {
      
    //   let newGemCode = 10000;
    //   let date = new Date()
    //   let year= date.getFullYear()

    //   this.nuevoCodigoGeminis = (this.ultimoCodigoDeGeminis + 1)
    //   this.nuevocodigoProgram   = 'S' + String(this.nuevoCodigoGeminis) + year

    // },
    convertHourDate (date, hours, minutes) {
      var d = new Date(date).toLocaleDateString('en-GB')
      var newString = d + ' ' + hours + ':' + minutes + ':' + '00'
      return newString 
    },
    // consultLastGeminisCode() {
    //   this.getSegments()
    //   this.getProgram()
    // },
    // validateEndDate () {
    //     if (this. formSegment.validity[0].startValidity > this.formSegment.validity[0].endValidity) {
    //         this. formSegment.validity[0].endValidity = this.formSegment.validity[0].startValidity
    //     }
    // },
  },
  watch: {
    verifyChangeModal(val) {
      this.contador += 1
    },
    'formSegment.scheduleStartHour'(val) {
      this.formSegment.scheduleStartHour = validateTime(val, 23)
    },
    'formSegment.scheduleStartMin'(val) {
      this.formSegment.scheduleStartMin = validateTime(val, 59)
    },
    'formSegment.scheduleEndHour'(val) {
      this.formSegment.scheduleEndHour = validateTime(val, 23)
    },
    'formSegment.scheduleEndMin'(val) {
      this.formSegment.scheduleEndMin = validateTime(val, 59)
    },
  }
}
</script>
